'VBScript helper script for use with VeryPDFPCLConverter print adapter

'Instead of performing these script actions in the print adapter script
'we use this helper .vbs script. This is because:
'   1) We have several steps that need to be performed sequentially
'   2) The WshShell.Run() function has an option to suspend the script
'      until the command completes.
'   3) AccuTerm's Shell() function cannot suspend, waiting for completion.

Dim Args, WshShell, Path, Cmd, Tmp, Pdf, Printer

Set Args = WScript.Arguments
If Args.Count >= 2 Then
	Set WshShell = WScript.CreateObject("WScript.Shell")
	Path = WshShell.Environment.Item("ProgramFiles")
	If Path = "" Then Path = "C:\Program Files"
	Path = Path & "\VeryPDF PCL Converter v2.0\"
	Cmd = """" & Path & "pcltool.exe"""
	Cmd = Cmd & " -noempty"
	Tmp = Args(0)
	Pdf = Args(1)
	Cmd = Cmd & " """ & Tmp & """ """ & Pdf & """"

	'convert pcl print job to pdf file
	WshShell.Run Cmd, 0, TRUE

	'note: Acrord32.exe prints best & fastest, but only works with the default printer!

	Cmd = "AcroRd32.exe /s /n /h"
	If Args.Count >= 3 Then
		'Printer = Args(2)
		'Cmd = Cmd & " /t """ & Pdf & """ """ & Printer & """"
		'acrord32.exe requires printer driver & port names, and even with these, it doesnt work!
		MsgBox "Unable to print to non-default printer using Adobe Reader (Acrord32.exe)",, "VeryPDFPCLConverter.vbs"
	Else
		Cmd = Cmd & " /t """ & Pdf & """"
	End If

	'note: VeryPDF pdfprint.exe prints without a GUI, but is very slow
	'and print quality is not good!

	'Cmd = """" & Path & "pdfprint_cmd\pdfprint.exe"""
	'If Args.Count >= 3 Then
	'	Printer = Args(2)
	'	Cmd = Cmd & " -printer """ & Printer & """"
	'End If
	'Cmd = Cmd & " """ & Pdf & """"

	'print pdf file
	WshShell.Run Cmd, 0, TRUE

	'clean up by deleting temp print job & pdf files
	Dim FSO, TmpFile, PdfFile
	Set FSO = WScript.CreateObject("Scripting.FileSystemObject")
	Set TmpFile = FSO.GetFile(Tmp)
	TmpFile.Delete
	Set PdfFile = FSO.GetFile(Pdf)
	PdfFile.Delete

End If