* SQL.CLS
* MySQL / SQSH interface
* Copyright (c) 2010 Ladybridge Systems, All Rights Reserved
*
* START-HISTORY:
* 22 May 10  2.10-4 New program.
* END-HISTORY
*
* START-DESCRIPTION:
*
* This class module provides a simple interface to MySQL or sqsh for low
* volume SQL interactions.
*
* END-DESCRIPTION
*
* START-CODE

class sql.cls
$catalogue !sql.cls

   private server.mode     ;* mysql or sqsh
   private servername      ;* Name of database server
   private username        ;* User name for server
   private password        ;* Password for server
   private database        ;* Database

   public interface        ;* Interface name (sqsh only)
   public status readonly  ;* Exit status from last command

* ----------------------------------------------------------------------
   public subroutine create.object(mode, server, user, pw, db)
      if listindex('mysql;sqsh', ';', mode) then
         server.mode = mode
         servername = server
         username = user
         password = pw
         database = db
      end
   end

* ----------------------------------------------------------------------
   public function execute(stmt, result) var.args
      begin case
         case server.mode = 'mysql'
            cmd = 'mysql -h':servername:' -u':username:' -p':password:' ':database:' 2>&1'

         case server.mode = 'sqsh'
            cmd = 'sqsh -S':servername:' -D':database:' -U':username:' -P':password:' -I':interface
      end case

      os.execute 'echo "' : stmt : '" | ' : cmd capturing result
      status = if status() then status() else os.error()
      return status() = 0
   end

end

* END-CODE
