/* qmclilib.h
 * QM client C API library functions and tokens.
 * Copyright (c) 2011 Ladybridge Systems, All Rights Reserved
 */

#ifndef __qmclilib__
#define __qmclilib__

/* Function definitions */

#ifdef __BORLANDC__
   /* Borland C compiler for Windows users */
   #define DLLEntry __declspec(dllimport)
#endif

#ifdef _MSC_VER
   /* Microsoft C compiler for Windows users */
   #define DLLEntry __declspec(dllimport)

 #ifndef __cplusplus
   #define QMCall _QMCall
   #define QMCallx _QMCallx
   #define QMChange _QMChange
   #define QMChecksum _QMChecksum
   #define QMClearSelect _QMClearSelect
   #define QMClose _QMClose
   #define QMConnect _QMConnect
   #define QMConnected _QMConnected
   #define QMConnectionType _QMConnectionType
   #define QMConnectLocal _QMConnectLocal
   #define QMDcount _QMDcount
   #define QMDebug _QMDebug
   #define QMDecrypt _QMDecrypt
   #define QMDel _QMDel
   #define QMDelete _QMDelete
   #define QMDeleteu _QMDeleteu
   #define QMDisconnect _QMDisconnect
   #define QMDisconnectAll _QMDisconnectAll
   #define QMEncrypt _QMEncrypt
   #define QMEndCommand _QMEndCommand
   #define QMError _QMError
   #define QMExecute _QMExecute
   #define QMExtract _QMExtract
   #define QMField _QMField
   #define QMFree _QMFree
   #define QMGetArg _QMGetArg
   #define QMGetSession _QMGetSession
   #define QMGetVar _QMGetVar
   #define QMIns _QMIns
   #define QMLocate _QMLocate
   #define QMLogto _QMLogto
   #define QMMarkMapping _QMMarkMapping
   #define QMMatch _QMMatch
   #define QMMatchfield _QMMatchfield
   #define QMNextPartial _QMNextPartial
   #define QMOpen _QMOpen
   #define QMRead _QMRead
   #define QMReadl _QMReadl
   #define QMReadList _QMReadList
   #define QMReadNext _QMReadNext
   #define QMReadu _QMReadu
   #define QMRecordlock _QMRecordlock
   #define QMRecordlocked _QMRecordlocked
   #define QMRelease _QMRelease
   #define QMReplace _QMReplace
   #define QMRespond _QMRespond
   #define QMRevision _QMRevision
   #define QMSelect _QMSelect
   #define QMSelectIndex _QMSelectIndex
   #define QMSelectLeft _QMSelectLeft
   #define QMSelectPartial _QMSelectPartial
   #define QMSelectRight _QMSelectRight
   #define QMSetLeft _QMSetLeft
   #define QMSetRight _QMSetRight
   #define QMSetSession _QMSetSession
   #define QMStatus _QMStatus
   #define QMTrapCallAbort _QMTrapCallAbort
   #define QMWrite _QMWrite
   #define QMWriteu _QMWriteu
 #endif
#endif

#ifndef DLLEntry
   /* Other platforms */
   #define DLLEntry
#endif
//*

/* 8-bit character APIs */

DLLEntry void QMCall(char * subrname, short int argc, ...);
DLLEntry int QMCallx(char * subrname, short int argc, ...);
DLLEntry char * QMChange(char * src, char * old_string, char * new_string, int occurrences, int start);
DLLEntry int QMChecksum(char * src);
DLLEntry void QMClearSelect(int listno);
DLLEntry void QMClose(int fno);
DLLEntry int QMConnect(char * host, int port, char * username, char * password, char * account);
DLLEntry int QMConnected(void);
DLLEntry void QMConnectionType(int type);
DLLEntry int QMConnectLocal(char * account);
DLLEntry int QMDcount(char * src, char * delim_str);
DLLEntry void QMDebug(int state);
DLLEntry char * QMDecrypt(char * data, char * keystring);
DLLEntry char * QMDel(char * src, int fno, int vno, int svno);
DLLEntry void QMDelete(int fno, char * id);
DLLEntry void QMDeleteu(int fno, char * id);
DLLEntry void QMDisconnect(void);
DLLEntry void QMDisconnectAll(void);
DLLEntry char * QMEncrypt(char * data, char * keystring);
DLLEntry void QMEndCommand(void);
DLLEntry char * QMError(void);
DLLEntry char * QMExecute(char * cmnd, int * err);
DLLEntry char * QMExtract(char * src, int fno, int vno, int svno);
DLLEntry char * QMField(char * src, char * delim, int first, int occurrences);
DLLEntry void QMFree(void * p);
DLLEntry char * QMGetArg(short int argno);
DLLEntry int QMGetSession(void);
DLLEntry char * QMGetVar(char * name);
DLLEntry char * QMIns(char * src, int fno, int vno, int svno, char * new_string);
DLLEntry int QMLocate(char * item, char * src, int fno, int vno, int svno, int * pos, char * order);
DLLEntry int QMLogto(char * account);
DLLEntry void QMMarkMapping(int fno, int state);
DLLEntry int QMMatch(char * str, char * pattern);
DLLEntry char * QMMatchfield(char * str, char * pattern, int component);
DLLEntry char * QMNextPartial(short int listno);
DLLEntry int QMOpen(char * filename);
DLLEntry char * QMRead(int fno, char * id, int * err);
DLLEntry char * QMReadl(int fno, char * id, int wait, int * err);
DLLEntry char * QMReadList(int listno);
DLLEntry char * QMReadNext(short int listno);
DLLEntry char * QMReadu(int fno, char * id, int wait, int * err);
DLLEntry void QMRecordlock(int fno, char * id, int update, int wait);
DLLEntry int QMRecordlocked(int fno, char * id);
DLLEntry void QMRelease(int fno, char * id);
DLLEntry char * QMReplace(char * src, int fno, int vno, int svno, char * new_string);
DLLEntry char * QMRespond(char * response, int * err);
DLLEntry char * QMRevision(void);
DLLEntry void QMSelect(int fno, int listno);
DLLEntry void QMSelectIndex(int fno, char * indexname, char * indexvalue, int listno);
DLLEntry char * QMSelectLeft(int fno, char * indexname, int listno);
DLLEntry char * QMSelectPartial(short int fileno, short int listno);
DLLEntry char * QMSelectRight(int fno, char * indexname, int listno);
DLLEntry void QMSetLeft(int fno, char * indexname);
DLLEntry void QMSetRight(int fno, char * indexname);
DLLEntry int QMSetSession(int session);
DLLEntry int QMStatus(void);
DLLEntry void QMTrapCallAbort(int mode);
DLLEntry void QMWrite(int fno, char * id, char * data);
DLLEntry void QMWriteu(int fno, char * id, char * data);

/* Wide character APIs
   Note that Windows defines wchar_t to be 16 bits, gcc as 32 bits */

DLLEntry void QMCallW(wchar_t * subrname, short int argc, ...);
DLLEntry int QMCallxW(wchar_t * subrname, short int argc, ...);
DLLEntry wchar_t * QMChangeW(wchar_t * src, wchar_t * old, wchar_t * newstr, int occurrences, int start);
DLLEntry int QMChecksumW(wchar_t * src);
DLLEntry int QMConnectW(wchar_t * host, int port, wchar_t * username, wchar_t * password, wchar_t * account);
DLLEntry int QMConnectLocalW(wchar_t * account);
DLLEntry int QMDcountW(wchar_t * src, wchar_t * delim_str);
DLLEntry wchar_t * QMDelW(wchar_t * src, int fno, int vno, int svno);
DLLEntry int QMDeleteW(int fno, wchar_t * id);
DLLEntry int QMDeleteuW(int fno, wchar_t * id);
DLLEntry int QMEnterPackageW(wchar_t * name_in);
DLLEntry wchar_t * QMErrorW(void);
DLLEntry wchar_t * QMExecuteW(wchar_t * cmnd_in, int * err);
DLLEntry int QMExitPackage(wchar_t * name_in);
DLLEntry wchar_t * QMExtractW(wchar_t * src, int fno, int vno, int svno);
DLLEntry wchar_t * QMFieldW(wchar_t * src, wchar_t * delim, int first, int occurrences);
DLLEntry wchar_t * QMGetArgW(short int argno);
DLLEntry wchar_t * QMGetVarW(wchar_t * name_in);
DLLEntry wchar_t * QMInsW(wchar_t * src, int fno, int vno, int svno, wchar_t * newstr);
DLLEntry int QMIsECS(void);
DLLEntry int QMLocateW(wchar_t * item, wchar_t * src, int fno, int vno, int svno, int * pos, wchar_t * order);
DLLEntry int QMLogtoW(wchar_t * account);
DLLEntry wchar_t * QMMatchfieldW(wchar_t * str, wchar_t * pattern, int component);
DLLEntry int QMMatchW(wchar_t * str, wchar_t * pattern);
DLLEntry int QMOpenW(wchar_t * filename);
DLLEntry wchar_t * QMReadListW(int listno);
DLLEntry wchar_t * QMReadNextW(short int listno);
DLLEntry wchar_t * QMReadW(int fno,  wchar_t * id, int * err);
DLLEntry wchar_t * QMReadlW(int fno,  wchar_t * id, int wait, int * err);
DLLEntry wchar_t * QMReaduW(int fno,  wchar_t * id, int wait, int * err);
DLLEntry int QMRecordlockedW(int fno, wchar_t * id);
DLLEntry void QMRecordlockW(int fno, wchar_t * id_in, int update_lock, int wait);
DLLEntry wchar_t * QMReleaseW(int fno,  wchar_t * id);
DLLEntry wchar_t * QMReplaceW(wchar_t * src, int fno, int vno, int svno, wchar_t * newstr);
DLLEntry wchar_t * QMRespondW(wchar_t * response_in, int * err);
DLLEntry wchar_t * QMRevisionW(void);
DLLEntry void QMSelectIndexW(short int fno, wchar_t * index_name_in, wchar_t * index_value_in, short int listno);
DLLEntry wchar_t * QMSelectLeftW(short int fno, wchar_t * index_name_in, short int listno);
DLLEntry wchar_t * QMSelectRightW(short int fno, wchar_t * index_name_in, short int listno);
DLLEntry void QMSetLeftW(short int fno, wchar_t * index_name_in);
DLLEntry void QMSetRightW(short int fno, wchar_t * index_name_in);
DLLEntry wchar_t * QMWriteW(int fno, wchar_t * id, wchar_t * data);
DLLEntry wchar_t * QMWriteuW(int fno, wchar_t * id, wchar_t * data);

/* Server error status values */

#define SV_OK             0    /* Action successful                       */
#define SV_ON_ERROR       1    /* Action took ON ERROR clause             */
#define SV_ELSE           2    /* Action took ELSE clause                 */
#define SV_ERROR          3    /* Action failed. Error text available     */
#define SV_LOCKED         4    /* Action took LOCKED clause               */
#define SV_PROMPT         5    /* Server requesting input                 */

#endif

/* END-CODE */


